<template>
    <div class="login">
        <q-page class="row items-center justify-evenly background-content">
            <div class="home-page-content">
                <div class="top-nav-bar">
                    <div
                        class="
                            row
                            q-pa-md q-py-md-md q-py-xs-sm
                            home-page-title
                        "
                    >
                        <div
                            class="
                                col-1
                                row
                                justify-center
                                items-center
                                q-pr-lg
                                gt-sm
                            "
                        >
                            <notifications />
                        </div>
                    </div>
                </div>
            </div>
            <div class="page-content q-pa-lg">
                <div class="row q-px-md q-mb-md">
                    <div class="col-6 offset-3">
                        <q-img src="/images/lobbi-business.png" />
                    </div>
                </div>

                <!-- QR LOGIN -->
                <div class="row text-center" v-if="state.loginType == 1">
                    <div class="col-12">
                        <p class="helvetica-neue-medium font-16">
                            {{ $t('login.title') }}
                        </p>
                    </div>
                    <div class="col-12 q-mb-lg">
                        <vue-qrcode
                            v-if="hash !== ''"
                            :value="hash"
                            type="image/webp"
                            class="border-radius-10 w-70"
                        />
                    </div>
                    <div class="col-12 col-md-10 offset-md-1">
                        <q-btn
                            no-caps
                            outline
                            rounded
                            color="primary"
                            :label="$t('button.refreshQR')"
                            class="w-100"
                            @click="refreshQRCodePressed"
                        />
                    </div>
                </div>
                <div
                    class="row text-center q-pt-md"
                    v-if="state.loginType == 1"
                >
                    <div class="col-12">
                        <a
                            class="font-14 text-underline text-black"
                            @click="switchLogin(2)"
                            href="javascript:void(0)"
                        >
                            {{ $t('login.mobile') }}
                        </a>
                    </div>
                </div>

                <!-- MOBILE LOGIN -->
                <div class="row text-center" v-if="state.loginType == 2">
                    <div class="col-12">
                        <p class="helvetica-neue-medium font-16">
                            {{ $t('login.mobileTitle') }}
                        </p>
                    </div>
                    <div class="col-10 offset-1 q-mb-sm">
                        <q-input
                            bg-color="blue-2"
                            dense
                            class="border-radius-10"
                            v-model="state.phone"
                        >
                            <template v-slot:prepend>
                                <p class="text-black q-pl-sm q-pt-md font-14">
                                    +60
                                </p>
                            </template>
                        </q-input>
                    </div>
                    <div class="col-10 offset-1 q-mb-lg">
                        <q-input
                            bg-color="blue-2"
                            dense
                            type="password"
                            class="border-radius-10"
                            v-model="state.password"
                        >
                            <template v-slot:append>
                                <q-btn
                                    color="blue-5"
                                    dense
                                    flat
                                    label="Send OTP"
                                    class="text-normalCase q-pr-sm"
                                    :disable="state.otpBtn"
                                    @click="sendOTP"
                                />
                            </template>
                        </q-input>
                    </div>
                    <div class="col-10 offset-1">
                        <q-btn
                            no-caps
                            rounded
                            color="primary"
                            :label="$t('button.login')"
                            class="w-100"
                            @click="verifyOTP"
                        />
                    </div>
                </div>
                <div
                    class="row text-center q-pt-md"
                    v-if="state.loginType == 2"
                >
                    <div class="col-12">
                        <a
                            class="font-14 text-underline text-black"
                            @click="switchLogin(1)"
                            href="javascript:void(0)"
                        >
                            {{ $t('login.qr') }}
                        </a>
                    </div>
                </div>
            </div>
        </q-page>
    </div>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
import { useStore } from 'src/store';
import { defineComponent, reactive, ref, onMounted } from 'vue';
import generateRandomString from 'src/services/helpers/GenerateRandomString';
import { socket as socket2 } from 'boot/socket-secondary';
import { useRouter } from 'vue-router';
import Notifications from 'src/components/commons/Notifications.vue';
import { useI18n } from 'vue-i18n';

export default defineComponent({
    name: 'Login',
    components: {
        Notifications
    },
    setup() {
        // store
        const store = useStore();

        // router
        const router = useRouter();

        // localization
        const { t } = useI18n();

        // data
        const key = ref('');
        const hash = ref('');

        let state = reactive({
            loginType: 1, // 1: QR, 2: Mobile
            phone: '',
            password: '',
            otpBtn: false
        });

        // methods
        const refreshQRCodePressed = () => {
            // Remove listener on old hash socket
            const oldKey = key.value;
            setTimeout(() => {
                socket2.emit('unsubscribe', 'weblogin-' + oldKey);
            }, 5000);

            // Regenerate new QR code
            generateQR();
        };

        const generateQR = () => {
            key.value = generateRandomString(6);

            void store
                .dispatch('qr/generate', {
                    type: 'weblogin',
                    value: key.value
                })
                .then((_hash) => {
                    hash.value = _hash;

                    // Listen to new hash socket
                    socket2.emit('subscribe', 'weblogin-' + key.value);
                });
        };

        const switchLogin = (type: number) => {
            state.loginType = type;
        };

        const sendOTP = () => {
            if (state.phone) {
                store.dispatch('auth/requestCode', {
                    phone: '+60' + state.phone
                });
            } else {
                store.dispatch(
                    'notification/setList',
                    t('notification.require.phone')
                );
            }
        };

        const verifyOTP = async () => {
            if (state.phone && state.password) {
                await store
                    .dispatch('auth/verifyCode', {
                        phone: '+60' + state.phone,
                        code: state.password
                    })
                    .then((result) => {
                        if (result.status !== 200) {
                            store.dispatch(
                                'notification/setList',
                                result.message
                            );
                        } else {
                            setTimeout(() => {
                                // Redirect to home
                                router.replace({ name: 'home' });
                            }, 1000);
                        }
                    });
            } else {
                store.dispatch(
                    'notification/setList',
                    t('notification.require.phoneOtp')
                );
            }
        };

        // mounted
        onMounted(generateQR);

        return {
            hash,
            state,
            refreshQRCodePressed,
            switchLogin,
            sendOTP,
            verifyOTP
        };
    }
});
</script>
